#include "AsExtern.h"
#include "http.h"

typedef struct	{
	char	name[32];
	int		accessType;
	int		authenticationType;
}	REALM;
static REALM	s_realms[8];

void	http_init()
{
	memset(s_realms, 0, sizeof(REALM) * 8);
}

void	http_set_realm(int no, char* name, int accessType, int authenticationType)
{
	if (no < 0 || no > 7)	return;
	strncpy(s_realms[no].name, name, 31);
	s_realms[no].accessType = accessType;
	s_realms[no].authenticationType = authenticationType;
}

int	http_start(char* deviceName, int port)
{
	//	for http params
	HS_SERVER_PARAMETER	appParams;
	memset(&appParams, 0, sizeof(HS_SERVER_PARAMETER));
	appParams.Lengthofstructure = sizeof(HS_SERVER_PARAMETER);
	strcpy(appParams.deviceName,			deviceName);
	strcpy(appParams.thePagenameReturnTo,	"");
	strcpy(appParams.theUrlReturnTo,		"");
	strcpy(appParams.errorPageLinkStart,	"");
	appParams.connections					= 6;
	appParams.persistent_timeout			= 2000;
	appParams.session_timeout				= 1000;
	appParams.port							= port;
	appParams.ServerStartDate.tm_hour		= 12;
	appParams.ServerStartDate.tm_min		= 0;
	appParams.ServerStartDate.tm_sec		= 0;
	appParams.ServerStartDate.tm_mday		= 1;
	appParams.ServerStartDate.tm_mon		= 0;
	appParams.ServerStartDate.tm_year		= 105;
	strcpy(appParams.Server_thread_name,	"httpd");
	appParams.Server_thread_priority		= 16;
	appParams.Server_thread_sysstack		= 4096;
	appParams.Server_thread_usrstack		= 2048;
	appParams.PageNotFoundErrorPage			= NULL;
	appParams.ServerBusyErrorPage			= NULL;
	appParams.DigestUnsupportedErrorPage	= NULL;
	appParams.AccessNotAllowedErrorPage		= NULL;
	appParams.FilesystemErrorPage			= NULL;
	appParams.InputTooLargeErrorPage		= NULL;
	appParams.CopyRightPage					= NULL;
	appParams.UnexpectedMultipartErrorPage	= NULL;
	return NAHSStartServer(appParams);
}

void RpHSInitSecurityTable(void *serverdata)
{
	int	i;
	for (i = 0; i < 8; i++)	{
		if (s_realms[i].name[0] == 0)	continue;
		NAHttpSetRealmSecurity(i, s_realms[i].name, s_realms[i].accessType, s_realms[i].authenticationType);
	}
}
